unit DemoMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, DB, Tqbe_32, Menus, ExtCtrls, DBTables, Buttons, StdCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    OpenDialog2: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Query1: TMenuItem;
    About1: TMenuItem;
    Load1: TMenuItem;
    Execute1: TMenuItem;
    QBE1: TQBE;
    Panel3: TPanel;
    OpenTable1: TMenuItem;
    CloseTable1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    sbtnExit: TSpeedButton;
    tblSource: TTable;
    dsSource: TDataSource;
    dsQBE: TDataSource;
    btnOpenTable: TButton;
    btnCloseTable: TButton;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    btnLoadQuery: TButton;
    btnExecQuery: TButton;
    Panel1: TPanel;
    Panel2: TPanel;
    gridTable: TDBGrid;
    Panel4: TPanel;
    Panel5: TPanel;
    gridAnswer: TDBGrid;
    Panel6: TPanel;
    Panel7: TPanel;
    memoQueryText: TMemo;
    btnCloseAnswer: TButton;
    IDentification: TPanel;
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure OpenTable1Click(Sender: TObject);
    procedure CloseTable1Click(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure Execute1Click(Sender: TObject);
    procedure btnCloseAnswerClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses About;

{$R *.DFM}

procedure TForm1.About1Click(Sender: TObject);
begin
  AboutBox.showmodal;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  if QBE1.Active then QBE1.Close;
  application.processmessages;
  if tblSource.Active then tblSource.Close;
  application.processmessages;
  close;
end;

procedure TForm1.OpenTable1Click(Sender: TObject);
begin
  If tblSource.Active then tblSource.Close;
  OpenDialog1.Execute;
  if length(trim(OpenDialog1.FileName))<>0 then
    tblSource.TableName := OpenDialog1.FileName;
  try
    tblSource.Open;
    Panel2.caption:='Table '+ OpenDialog1.FileName;
    Panel2.repaint;
  except
    showmessage('Unable to open table '+OpenDialog1.FileName);
  end;
end;

procedure TForm1.CloseTable1Click(Sender: TObject);
begin
  tblSource.Close;
  Panel2.caption:='';
  Panel2.repaint;
end;

procedure TForm1.Load1Click(Sender: TObject);
var
I : Integer;
begin
  If QBE1.Active then QBE1.Close;
  OpenDialog2.Execute;
  if length(trim(OpenDialog2.FileName))<>0 then
    QBE1.QBE.LoadFromFile(OpenDialog2.FileName);
    for I:=0 to QBE1.QBE.count - 1 do
      MemoQueryText.lines.add(QBE1.QBE.strings[i]);
    MemoQueryText.repaint;
    panel7.caption:= 'QBE Statment loaded from file '+OpenDialog2.FileName;
    panel7.repaint;
end;

procedure TForm1.Execute1Click(Sender: TObject);
begin
 if (not (QBE1.QBE.count=0)) then
   begin
     QBE1.Active:=True;
     application.processmessages;
     Panel5.Caption:= 'Answer';
   end
 else
   showmessage('QBE statment is empty. Please create a QBE in the Borland Database'+
   'Desktop, save it as a file and than load into the component.');
end;

procedure TForm1.btnCloseAnswerClick(Sender: TObject);
begin
  if QBE1.Active then QBE1.Active := False;
  application.processmessages;
  memoQueryText.clear;
  application.processmessages;
  Panel5.Caption:= '';
  Panel5.repaint;
  Panel7.Caption:= '';
  Panel7.repaint;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  Identification.Caption:='Version: '+ qbe1.Version +'  '+qbe1.Amber;

end;

end.
